/*
 * Copied from vorbis-tools.
 */

#ifndef __VCEDIT_H
#define __VCEDIT_H

#include <stdio.h>
#include <ogg/ogg.h>
#include <vorbis/codec.h>

typedef struct {
	ogg_sync_state *oy;
	ogg_stream_state *os;

	vorbis_comment *vc;
	vorbis_info *vi;

	FILE *in;
	long serial;
	unsigned char *mainbuf;
	unsigned char *bookbuf;
	int mainlen;
	int booklen;
	const char *lasterror;
	char *vendor;
	int prevW;
	int extrapage;
	int eosin;
} vcedit_state;

vcedit_state *vcedit_new_state(void);
void vcedit_clear(vcedit_state *state);
int vcedit_open(vcedit_state *state, FILE *in);
int vcedit_write(vcedit_state *state, FILE *out);
const char *vcedit_error(vcedit_state *state);

#endif
